/* Compilar com "gcc -g -pg"
 * Apos execucao, usar "gprof a.out gmon.out"
 */

#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>
#include <sys/resource.h>

static void print_stkusage()
{
  struct rusage stack;

  getrusage (RUSAGE_SELF, &stack);

  fprintf (stderr, "\t\tSTACK USAGE = %lu\n", stack.ru_isrss);
}

static void print_stklim()
{
  struct rlimit stack;

  getrlimit (RLIMIT_STACK, &stack);

  fprintf (stderr, "\t\tSTACK LIMIT = %lu\n", stack.rlim_cur);
}

int f(int i)
{
  print_stkusage();
  if (i > 1)
    return (i + f(i-1));
  else
    return (1);

}

 main(int argc, char *argv[])
{
   long int i, limite;

   if (argc > 1)
      limite=atol(argv[1]);
   else
      limite=20;

   printf ("Limite = %ld\n", limite);
   print_stklim();
   printf ("Aguarde ..... ");

   printf ("F() = %u\n", f(limite));

   printf ("Acabou !!!!!\n");
}


